from strictyaml.ruamel.compat import text_type
from typing import Any, Text, SupportsIndex

class ScalarString(text_type):
    def __new__(cls, *args: Any, **kw: Any) -> Any: ...
    def replace(self, old: Any, new: Any, maxreplace: SupportsIndex = ...) -> Any: ...
    @property
    def anchor(self) -> Any: ...
    def yaml_anchor(self, any: bool = ...) -> Any: ...
    def yaml_set_anchor(self, value: Any, always_dump: bool = ...) -> None: ...

class LiteralScalarString(ScalarString):
    style: str
    def __new__(cls, value: Text, anchor: Any = ...) -> Any: ...

PreservedScalarString = LiteralScalarString

class FoldedScalarString(ScalarString):
    style: str
    def __new__(cls, value: Text, anchor: Any = ...) -> Any: ...

class SingleQuotedScalarString(ScalarString):
    style: str
    def __new__(cls, value: Text, anchor: Any = ...) -> Any: ...

class DoubleQuotedScalarString(ScalarString):
    style: str
    def __new__(cls, value: Text, anchor: Any = ...) -> Any: ...

class PlainScalarString(ScalarString):
    style: str
    def __new__(cls, value: Text, anchor: Any = ...) -> Any: ...
